#include "BaseGrid.hpp"

using namespace API;
using namespace std;

// Pointers to grids
BaseGrid* API_activeGrid = NULL;
vector<BaseGrid*> API_allGrids;

// Add the grid to the UI
void (*ext_add_grid_to_ui)( BaseGrid* grid ) = NULL;

// Stores the grid in a vector
void api_store_new_grid( BaseGrid* grid )
{
  API_allGrids.push_back( grid );
  
  if( ext_add_grid_to_ui )
    ext_add_grid_to_ui( grid );
}

// Returns all grids
vector<BaseGrid*> api_get_all_grids()
{
  return API_allGrids;
}

BaseGrid::BaseGrid() : m_name("Basic Grid")
{
}

BaseGrid::BaseGrid(const BaseGrid& grid) : m_name(grid.m_name)
{

}

BaseGrid::~BaseGrid()
{
    for(unsigned int i=0;i<_cells.size();i++)
    {
        delete _cells.at(i);
    }
}

/*!
 * \brief Get Cell
 *
 * \param index
 */
BaseCell* BaseGrid::getCell(unsigned int i)
{
    return _cells[i];
}

/*!
 * \brief Get Number Of Cells
 */
unsigned int BaseGrid::getNumberOfCells()
{
    return _cells.size();
}

/*!
 * @breif
 */
std::vector<Eigen::Vector3d> BaseGrid::getBox()
{
	std::vector<Eigen::Vector3d> vect;
	vect.clear();
	return vect;
}

/*!
 * \brief Virtual function for
 * creating an xml document
 */
bool BaseGrid::writeToXmlFile(std::string file)
{
	return true;
}

/*!
 * \brief Virtual function for
 * reading from an xml document
 */
bool BaseGrid::loadFromXmlFile(std::string file)
{
	return true;
}
