/*
 * Multi-TRRT.hpp
 *
 *  Created on: Nov 29, 2012
 *      Author: ddevaurs
 */

#ifndef MULTI_TRRT_HPP_
#define MULTI_TRRT_HPP_

#include "planner/Diffusion/RRT.hpp"


/**
 * The Multi T-RRT algorithm.
 */
class MultiTRRT: public RRT
{
public:
    //! Constructor.
    MultiTRRT(Robot * R, Graph * G) : RRT(R, G) {
        std::cout << "Construct the Multi T-RRT" << std::endl;
    }

    //! Destructor.
    virtual ~MultiTRRT() {};

    /**
     * Initialize the Multi T-RRT.
     * @return the number of nodes added to the graph
     */
    unsigned init();

    /**
     * Check whether one of the stopping conditions is satisfied.
     * @return TRUE if one of them is satisfied
     */
    bool checkStopConditions();

    /**
     * Main function of the Multi T-RRT.
     * @return the number of nodes added to the graph
     */
    unsigned run();

    //! Extract a trajectory going through all the waypoints.
    API::Trajectory * getTrajectory();

private:
    //! seeds of the connected components of the graph
	std::vector<confPtr_t> seeds;
};

#endif
