/*
 *  SimpleReplanner.hpp
 *  libmove3D-planners 
 *
 *  Created by Benjamin Vadant on 01/02/13.
 *  Based on Jim Mainprice replanningAlgorithms.hpp/cpp
 *  Copyright 2013 LAAS/CNRS. All rights reserved.
 *
 */

#ifndef SIMPLE_REPLANNER_HPP
#define SIMPLE_REPLANNER_HPP

#include "Replanner.hpp"
#include "API/Trajectory/trajectory.hpp"
#include "API/ConfigSpace/configuration.hpp"
#include "API/Roadmap/graph.hpp"

#include "HRI_costspace/HRICS_Navigation.hpp"

#include "utils/ConfGenerator.h"

#include "P3d-pkg.h"
#include "LightPlanner-pkg.h"

#include <string>

class SimpleReplanner : public Replanner
{   
public:
    SimpleReplanner(Robot* r);
    ~SimpleReplanner();
    
    bool init();
    void run();
    
protected:
    void setActiveJoints(int set);
    void initActiveJoints();
    void initForNavigation();
    void initForManipulation();
    void initForMobileManipulation();
    bool initCreateStraightline();
    
    enum ReplanningType 
    { 
        NAVIGATION = 0, 
        MANIPULATION = 1, 
        MOBILE_MANIP = 2 
    } 
    replanningType; 
};

#endif
