/*
 *  StompReplanner.hpp
 *  libmove3D-planners 
 *
 *  Created by Benjamin Vadant on 01/02/13.
 *  Based on Jim Mainprice replanningAlgorithms.hpp/cpp
 *  Copyright 2013 LAAS/CNRS. All rights reserved.
 *
 */

#ifndef STOMP_REPLANNER_HPP
#define STOMP_REPLANNER_HPP

#include "planner/Replanning/SimpleReplanner.hpp"
#include "API/Trajectory/trajectory.hpp"
#include "API/ConfigSpace/configuration.hpp"
#include "API/Roadmap/graph.hpp"

#include "HRI_costspace/HRICS_Navigation.hpp"

#include "utils/ConfGenerator.h"

#include "P3d-pkg.h"
#include "LightPlanner-pkg.h"

#include <string>

class StompReplanner : public SimpleReplanner
{   
public:
    StompReplanner(Robot* r);
    ~StompReplanner();
    
    bool init();
    void run();
    
};

#endif
